"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = apiMediaDELETE;
const query_dsql_api_1 = __importDefault(require("../../functions/api/query-dsql-api"));
const path_1 = __importDefault(require("path"));
const grab_api_base_path_1 = __importDefault(require("../../utils/grab-api-base-path"));
function apiMediaDELETE(params) {
    return __awaiter(this, void 0, void 0, function* () {
        const basePath = (0, grab_api_base_path_1.default)({ paradigm: "media" });
        const mediaID = params.mediaID
            ? typeof params.mediaID === "number"
                ? String(params.mediaID)
                : params.mediaID
            : undefined;
        const finalPath = path_1.default.join(basePath, mediaID || "");
        const DELETE_MEDIA_RES = yield (0, query_dsql_api_1.default)({
            method: "DELETE",
            path: finalPath,
            apiKey: params.apiKey,
        });
        return DELETE_MEDIA_RES;
    });
}
