"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = suDbHandler;
const serverless_mysql_1 = __importDefault(require("serverless-mysql"));
const conn_db_handler_1 = __importDefault(require("../../utils/db/conn-db-handler"));
function suDbHandler(_a) {
    return __awaiter(this, arguments, void 0, function* ({ query, database, user, values, }) {
        const connection = (0, serverless_mysql_1.default)({
            config: {
                host: process.env.DSQL_DB_HOST,
                user: process.env.DSQL_DB_USERNAME,
                password: process.env.DSQL_DB_PASSWORD,
                database: database,
                charset: "utf8mb4",
            },
        });
        const results = yield (0, conn_db_handler_1.default)(connection, query);
        return results;
    });
}
