"use strict";
// @ts-check
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = default_1;
const parseCookies_1 = __importDefault(require("../../utils/backend/parseCookies"));
const decrypt_1 = __importDefault(require("../dsql/decrypt"));
const get_auth_cookie_names_1 = __importDefault(require("./cookies/get-auth-cookie-names"));
function default_1(req) {
    return __awaiter(this, void 0, void 0, function* () {
        const { keyCookieName, csrfCookieName } = (0, get_auth_cookie_names_1.default)();
        const suKeyName = `${keyCookieName}_su`;
        const cookies = (0, parseCookies_1.default)({ request: req });
        if (!(cookies === null || cookies === void 0 ? void 0 : cookies[suKeyName])) {
            return null;
        }
        /** ********************* Grab the payload */
        let userPayload = (0, decrypt_1.default)({
            encryptedString: cookies[suKeyName],
        });
        /** ********************* Return if no payload */
        if (!userPayload)
            return null;
        /** ********************* Parse the payload */
        let userObject = JSON.parse(userPayload);
        if (userObject.password !== process.env.DSQL_USER_KEY)
            return null;
        if (userObject.authKey !== process.env.DSQL_SPECIAL_KEY)
            return null;
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        /** ********************* return user object */
        return userObject;
    });
}
