import { DsqlCrudQueryObject } from "../../../../types";
import { DsqlTables } from "../../../../types/dsql";
export type GrabUserResourceParams<T extends {
    [k: string]: any;
} = any> = {
    query?: DsqlCrudQueryObject<T>;
    userId?: string | number;
    tableName: (typeof DsqlTables)[number];
    count?: boolean;
    countOnly?: boolean;
    noLimit?: boolean;
    isSuperUser?: boolean;
    targetID?: string | number;
};
export default function dbGrabUserResource<T extends {
    [k: string]: any;
} = any>(params: GrabUserResourceParams<T>): Promise<{
    batch: T[] | null;
    single: T | null;
    debug: {
        queryObject: {
            sql?: string;
            params?: string[];
        } | undefined;
        error: any;
        msg: string | undefined;
    };
    count: number;
}>;
