"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = handleMariadbUserGrantsForDatabasesCleanUpRecords;
const crud_1 = __importDefault(require("../../../utils/data-fetching/crud"));
function handleMariadbUserGrantsForDatabasesCleanUpRecords(_a) {
    return __awaiter(this, arguments, void 0, function* ({ user, updatedRecord, }) {
        /**
         * # Clean up Records
         */
        yield (0, crud_1.default)({
            action: "delete",
            table: "mariadb_user_databases",
            deleteData: {
                user_id: user.id,
                mariadb_user_id: updatedRecord.id,
            },
        });
        yield (0, crud_1.default)({
            action: "delete",
            table: "mariadb_user_privileges",
            deleteData: {
                user_id: user.id,
                mariadb_user_id: updatedRecord.id,
            },
        });
        yield (0, crud_1.default)({
            action: "delete",
            table: "mariadb_user_tables",
            deleteData: {
                user_id: user.id,
                mariadb_user_id: updatedRecord.id,
            },
        });
        return { success: true };
    });
}
