"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = handleMariadbUserRecord;
const grab_sql_user_name_1 = __importDefault(require("../../../utils/grab-sql-user-name"));
const addDbEntry_1 = __importDefault(require("../../backend/db/addDbEntry"));
const encrypt_1 = __importDefault(require("../../dsql/encrypt"));
const grab_user_resource_1 = __importDefault(require("../db/grab-user-resource"));
function handleMariadbUserRecord(_a) {
    return __awaiter(this, arguments, void 0, function* ({ mariadbUser, accessedDatabases, grants, isAllDbsAccess, isAllGrants, user, }) {
        var _b, _c, _d;
        const { name: finalMariadbUserName } = (0, grab_sql_user_name_1.default)({
            name: mariadbUser.username,
            user,
        });
        const finalPassword = (_b = mariadbUser.password) === null || _b === void 0 ? void 0 : _b.replace(/ /g, "");
        if (!finalPassword)
            return { msg: `Couldn't get password` };
        const encryptedFinalPassword = (0, encrypt_1.default)({ data: finalPassword });
        const finalHost = (_c = mariadbUser.host) === null || _c === void 0 ? void 0 : _c.replace(/ /g, "");
        const newMariadbUser = {
            password: encryptedFinalPassword || undefined,
            username: finalMariadbUserName,
            all_databases: isAllDbsAccess ? 1 : 0,
            all_grants: isAllGrants ? 1 : 0,
            host: finalHost,
            user_id: user.id,
        };
        let { single: existingRecord } = yield (0, grab_user_resource_1.default)({
            tableName: "mariadb_users",
            userId: user.id,
            query: {
                query: {
                    id: {
                        value: String(mariadbUser.id || 0),
                    },
                },
            },
        });
        const record = yield (0, addDbEntry_1.default)({
            tableName: "mariadb_users",
            data: newMariadbUser,
            update: true,
            duplicateColumnName: "id",
            duplicateColumnValue: ((existingRecord === null || existingRecord === void 0 ? void 0 : existingRecord.id) || 0).toString(),
        });
        let { single: updatedRecord } = yield (0, grab_user_resource_1.default)({
            tableName: "mariadb_users",
            userId: user.id,
            query: {
                query: {
                    id: {
                        value: String((existingRecord === null || existingRecord === void 0 ? void 0 : existingRecord.id) || ((_d = record === null || record === void 0 ? void 0 : record.payload) === null || _d === void 0 ? void 0 : _d.insertId) || 0),
                    },
                },
            },
        });
        return { existingRecord, updatedRecord };
    });
}
