"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = checkDbRecordCreateDbSchema;
const varDatabaseDbHandler_1 = __importDefault(require("../utils/varDatabaseDbHandler"));
const numberfy_1 = __importDefault(require("../../utils/numberfy"));
const addDbEntry_1 = __importDefault(require("../../functions/backend/db/addDbEntry"));
const updateDbEntry_1 = __importDefault(require("../../functions/backend/db/updateDbEntry"));
/**
 * # Create database from Schema Function
 * @requires DSQL_DB_CONN - Gobal Variable for Datasquirel Database
 */
function checkDbRecordCreateDbSchema(_a) {
    return __awaiter(this, arguments, void 0, function* ({ userId, dbSchema, isMain, }) {
        var _b, _c;
        if (isMain)
            return undefined;
        try {
            const { dbFullName, dbName, dbSlug, dbDescription, dbImage, childDatabase, childDatabaseDbId, id, } = dbSchema;
            let recordedDbEntryArray = userId
                ? yield (0, varDatabaseDbHandler_1.default)({
                    queryString: `SELECT * FROM datasquirel.user_databases WHERE db_full_name = ?`,
                    queryValuesArray: [dbFullName || "NULL"],
                })
                : undefined;
            let recordedDbEntry = recordedDbEntryArray === null || recordedDbEntryArray === void 0 ? void 0 : recordedDbEntryArray[0];
            const newDbEntryObj = {
                user_id: (0, numberfy_1.default)(userId),
                db_name: dbName,
                db_slug: dbSlug,
                db_full_name: dbFullName,
                db_description: dbDescription,
                db_image: dbImage,
                active_clone: childDatabase ? 1 : undefined,
                db_schema_id: (0, numberfy_1.default)(id),
                active_clone_parent_db_id: (0, numberfy_1.default)(childDatabaseDbId),
            };
            if (!(recordedDbEntry === null || recordedDbEntry === void 0 ? void 0 : recordedDbEntry.id) && userId) {
                const newDbEntry = yield (0, addDbEntry_1.default)({
                    data: newDbEntryObj,
                    tableName: "user_databases",
                    forceLocal: true,
                });
                if ((_b = newDbEntry.payload) === null || _b === void 0 ? void 0 : _b.insertId) {
                    recordedDbEntryArray = yield (0, varDatabaseDbHandler_1.default)({
                        queryString: `SELECT * FROM datasquirel.user_databases WHERE db_full_name = ?`,
                        queryValuesArray: [dbFullName || "NULL"],
                    });
                    recordedDbEntry = recordedDbEntryArray === null || recordedDbEntryArray === void 0 ? void 0 : recordedDbEntryArray[0];
                }
            }
            else if (recordedDbEntry === null || recordedDbEntry === void 0 ? void 0 : recordedDbEntry.id) {
                yield (0, updateDbEntry_1.default)({
                    data: newDbEntryObj,
                    tableName: "user_databases",
                    forceLocal: true,
                    identifierColumnName: "id",
                    identifierValue: String(recordedDbEntry.id),
                });
            }
            return recordedDbEntry;
        }
        catch (error) {
            (_c = global.ERROR_CALLBACK) === null || _c === void 0 ? void 0 : _c.call(global, `Error Checking DB Record on Creating Schema`, error);
            return undefined;
        }
    });
}
