"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = handleTableForeignKey;
const varDatabaseDbHandler_1 = __importDefault(require("./varDatabaseDbHandler"));
/**
 * # Update table function
 */
function handleTableForeignKey(_a) {
    return __awaiter(this, arguments, void 0, function* ({ dbFullName, tableName, foreignKey, errorLogs, fieldName, }) {
        const { destinationTableName, destinationTableColumnName, cascadeDelete, cascadeUpdate, foreignKeyName, } = foreignKey;
        let finalQueryString = `ALTER TABLE \`${dbFullName}\`.\`${tableName}\``;
        finalQueryString += ` ADD CONSTRAINT \`${foreignKeyName}\` FOREIGN KEY (\`${fieldName}\`)`;
        finalQueryString += ` REFERENCES \`${destinationTableName}\`(\`${destinationTableColumnName}\`)`;
        if (cascadeDelete)
            finalQueryString += ` ON DELETE CASCADE`;
        if (cascadeUpdate)
            finalQueryString += ` ON UPDATE CASCADE`;
        // let foreinKeyText = `ADD CONSTRAINT \`${foreignKeyName}\` FOREIGN KEY (\`${destinationTableColumnType}\`) REFERENCES \`${destinationTableName}\`(\`${destinationTableColumnName}\`)${
        //     cascadeDelete ? " ON DELETE CASCADE" : ""
        // }${cascadeUpdate ? " ON UPDATE CASCADE" : ""}`;
        // let finalQueryString = `ALTER TABLE \`${dbFullName}\`.\`${tableName}\` ${foreinKeyText}`;
        const addForeignKey = yield (0, varDatabaseDbHandler_1.default)({
            queryString: finalQueryString,
        });
        if (!(addForeignKey === null || addForeignKey === void 0 ? void 0 : addForeignKey.serverStatus)) {
            errorLogs === null || errorLogs === void 0 ? void 0 : errorLogs.push(addForeignKey);
        }
    });
}
