export declare const DsqlTables: readonly ["users", "mariadb_users", "mariadb_user_databases", "mariadb_user_tables", "mariadb_user_privileges", "api_keys", "api_keys_scoped_resources", "invitations", "delegated_resources", "user_databases", "user_database_tables", "user_media", "user_private_folders", "delegated_users", "unsubscribes", "notifications", "deleted_api_keys", "servers", "process_queue", "backups"];
export type DSQL_DATASQUIREL_USERS = {
    id?: number;
    uuid?: string;
    first_name?: string;
    last_name?: string;
    uid?: string;
    email?: string;
    user_type?: string;
    user_priviledge?: number;
    username?: string;
    password?: string;
    image?: string;
    image_thumbnail?: string;
    social_login?: number;
    social_platform?: string;
    social_id?: string;
    mariadb_user?: string;
    mariadb_host?: string;
    mariadb_pass?: string;
    disk_usage_in_mb?: number;
    verification_status?: number;
    temp_login_code?: string;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_MARIADB_USERS = {
    id?: number;
    uuid?: string;
    user_id?: number;
    username?: string;
    host?: string;
    password?: string;
    primary?: number;
    all_databases?: 0 | 1;
    all_grants?: 0 | 1;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_MARIADB_USER_DATABASES = {
    id?: number;
    uuid?: string;
    user_id?: number;
    mariadb_user_id?: number;
    db_id?: number;
    db_schema_id?: number;
    db_slug?: string;
    all_tables?: 0 | 1;
    all_privileges?: 0 | 1;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_MARIADB_USER_TABLES = {
    id?: number;
    uuid?: string;
    user_id?: number;
    mariadb_user_id?: number;
    db_id?: number;
    db_schema_id?: number;
    db_slug?: string;
    table_schema_id?: number;
    table_slug?: string;
    all_fields?: 0 | 1;
    all_privileges?: 0 | 1;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_MARIADB_USER_PRIVILEGES = {
    id?: number;
    uuid?: string;
    user_id?: number;
    mariadb_user_id?: number;
    db_id?: number;
    db_schema_id?: number;
    db_slug?: string;
    privilege?: "ALTER" | "ALTER ROUTINE" | "CREATE" | "CREATE ROUTINE" | "CREATE TEMPORARY TABLES" | "CREATE VIEW" | "DELETE" | "DROP" | "EVENT" | "EXECUTE" | "FILE" | "INDEX" | "INSERT" | "LOCK TABLES" | "PROCESS" | "REFERENCES" | "RELOAD" | "SELECT" | "SHOW VIEW" | "SUPER" | "TRIGGER" | "UPDATE" | "USAGE";
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_API_KEYS = {
    id?: number;
    uuid?: string;
    user_id?: number;
    name?: string;
    slug?: string;
    key?: string;
    scope?: "readOnly" | "fullAccess";
    all_dbs?: 0 | 1;
    media_only?: 0 | 1;
    csrf?: string;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_API_KEYS_SCOPED_RESOURCES = {
    id?: number;
    uuid?: string;
    user_id?: number;
    api_key_id?: number;
    db_id?: number;
    db_schema_id?: number;
    db_slug?: string;
    table_schema_id?: number;
    table_slug?: string;
    all_tables?: 0 | 1;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_INVITATIONS = {
    id?: number;
    uuid?: string;
    user_id?: number;
    invited_user_id?: number;
    invited_user_email?: string;
    invitation_status?: "pending" | "accepted" | "rejected" | "cancelled";
    database_access?: string;
    db_tables_data?: string;
    email_sent?: 0 | 1;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_DELEGATED_RESOURCES = {
    id?: number;
    uuid?: string;
    delegated_users_id?: number;
    user_id?: number;
    delegated_user_id?: number;
    db_id?: number;
    db_schema_id?: number;
    db_slug?: string;
    table_schema_id?: number;
    table_slug?: string;
    permission?: "read" | "write" | "edit" | "delete";
    all_tables?: 0 | 1;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_USER_DATABASES = {
    id?: number;
    uuid?: string;
    user_id?: number;
    db_schema_id?: number;
    db_name?: string;
    db_slug?: string;
    db_full_name?: string;
    db_image?: string;
    db_description?: string;
    remote_connected?: number;
    remote_connection_type?: string;
    remote_db_full_name?: string;
    remote_connection_host?: string;
    remote_connection_key?: string;
    active_clone?: 0 | 1;
    active_clone_parent_db?: string;
    active_clone_parent_db_id?: number;
    active_data?: number;
    last_checked_date_code?: number;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_USER_DATABASE_TABLES = {
    id?: number;
    uuid?: string;
    user_id?: number;
    db_id?: number;
    table_schema_id?: number;
    db_slug?: string;
    table_name?: string;
    table_slug?: string;
    table_description?: string;
    child_table?: number;
    child_table_parent_database_schema_id?: number;
    child_table_parent_table_schema_id?: number;
    active_data?: 0 | 1;
    last_checked_date_code?: number;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_USER_MEDIA = {
    id?: number;
    uuid?: string;
    user_id?: number;
    media_name?: string;
    folder?: string;
    media_url?: string;
    media_thumbnail_url?: string;
    media_base64?: string;
    media_thumbnail_base64?: string;
    media_type?: "file" | "image" | "video";
    media_stats?: string;
    mime_type?: string;
    width?: number;
    height?: number;
    size?: number;
    private?: 0 | 1;
    private_folder?: 0 | 1;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_USER_PRIVATE_FOLDERS = {
    id?: number;
    uuid?: string;
    user_id?: number;
    folder_path?: string;
    child_folder?: 0 | 1;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_DELEGATED_USERS = {
    id?: number;
    uuid?: string;
    user_id?: number;
    delegated_user_id?: number;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_UNSUBSCRIBES = {
    id?: number;
    uuid?: string;
    user_id?: number;
    email?: string;
    type?: string;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_NOTIFICATIONS = {
    id?: number;
    uuid?: string;
    user_id?: number;
    title?: string;
    message?: string;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_DELETED_API_KEYS = {
    id?: number;
    uuid?: string;
    user_id?: number;
    key?: string;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_SERVERS = {
    id?: number;
    uuid?: string;
    server_id?: number;
    ip?: string;
    ssh_user?: string;
    ssh_port?: number;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_PROCESS_QUEUE = {
    id?: number;
    uuid?: string;
    user_id?: number;
    title?: string;
    job_type?: string;
    data?: string;
    running?: number;
    server_id?: number;
    error?: number;
    error_message?: string;
    success?: number;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
export type DSQL_DATASQUIREL_BACKUPS = {
    id?: number;
    uuid?: string;
    user_id?: number;
    date_created?: string;
    date_created_code?: number;
    date_created_timestamp?: string;
    date_updated?: string;
    date_updated_code?: number;
    date_updated_timestamp?: string;
};
