"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = DSQL_USER_DB_HANDLER;
const conn_db_handler_1 = __importDefault(require("../../db/conn-db-handler"));
const grab_dsql_connection_1 = __importDefault(require("../../grab-dsql-connection"));
/**
 * # DSQL user read-only DB handler
 */
function DSQL_USER_DB_HANDLER(_a) {
    return __awaiter(this, arguments, void 0, function* ({ paradigm, queryString, queryValues, }) {
        var _b;
        const CONNECTION = paradigm == "Read Only"
            ? (0, grab_dsql_connection_1.default)({ ro: true })
            : (0, grab_dsql_connection_1.default)({ fa: true });
        try {
            return yield (0, conn_db_handler_1.default)(CONNECTION, queryString, queryValues);
        }
        catch (error) {
            (_b = global.ERROR_CALLBACK) === null || _b === void 0 ? void 0 : _b.call(global, `DSQL_USER_DB_HANDLER Error`, error);
            return null;
        }
        finally {
            CONNECTION === null || CONNECTION === void 0 ? void 0 : CONNECTION.end();
        }
    });
}
