import { ServerlessMysql } from "serverless-mysql";
import { DSQLErrorObject } from "../../types";
export type ConnDBHandlerQueryObject = {
    query: string;
    values?: (string | number | undefined)[];
};
type Return<ReturnType = any> = ReturnType | null | {
    error?: string;
    errors?: DSQLErrorObject[];
};
/**
 * # Run Query From MySQL Connection
 * @description Run a query from a pre-existing MySQL/Mariadb Connection
 * setup with `serverless-mysql` npm module
 */
export default function connDbHandler<ReturnType = any>(
/**
 * ServerlessMySQL Connection Object
 */
conn?: ServerlessMysql, 
/**
 * String Or `ConnDBHandlerQueryObject` Array
 */
query?: ConnDBHandlerQueryObject["query"] | ConnDBHandlerQueryObject[], 
/**
 * Array of Values to Sanitize and Inject
 */
values?: ConnDBHandlerQueryObject["values"], debug?: boolean): Promise<Return<ReturnType>>;
export {};
