"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = grabDbNames;
const grab_db_full_name_1 = __importDefault(require("./grab-db-full-name"));
/**
 * # Grab full database name
 * @description Grab full database name from slug or full name
 * @param param0
 * @returns
 */
function grabDbNames({ dbName, userId, user }) {
    const dbNamePrefix = process.env.DSQL_USER_DB_PREFIX;
    const finalUserId = (user === null || user === void 0 ? void 0 : user.id) || userId;
    const userDbPrefix = `${dbNamePrefix}${finalUserId}_`;
    const dbFullName = (0, grab_db_full_name_1.default)({ dbName, user, userId });
    return { userDbPrefix, dbFullName, dbNamePrefix };
}
