"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = grabSQLUserName;
const grab_sql_user_name_for_user_1 = __importDefault(require("./grab-sql-user-name-for-user"));
function grabSQLUserName({ user, name: passedName, }) {
    if (!user) {
        console.log("No User Found");
        return {};
    }
    const sqlUsername = (0, grab_sql_user_name_for_user_1.default)(user.id);
    const parsedPassedName = passedName
        ? passedName.replace(sqlUsername, "").replace(/^_+|_+$/, "")
        : undefined;
    const name = parsedPassedName
        ? `${sqlUsername}_${parsedPassedName}`
        : undefined;
    if (user.isSuperUser) {
        return {
            sqlUsername: undefined,
            name: passedName,
            nameWithoutPrefix: passedName,
        };
    }
    return { sqlUsername, name, nameWithoutPrefix: parsedPassedName };
}
