declare const LogTypes: readonly ["error", "warning"];
type Param = {
    /**
     * data to be logged.
     */
    log: any;
    /**
     * Log Title. Could be name of function or name of variable
     */
    title?: string;
    /**
     * Label for the log
     */
    label?: string;
    /**
     * Log type. `error` or `warning` or default
     */
    type?: (typeof LogTypes)[number];
    /**
     * Whether to add a time stamp
     */
    addTime?: boolean;
};
export default function debugLog({ log, label, title, type, addTime }: Param): void;
export {};
