"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = purgeDefaultFields;
const lodash_1 = __importDefault(require("lodash"));
const default_fields_regexp_1 = __importDefault(require("../functions/dsql/default-fields-regexp"));
function purgeDefaultFields(entry) {
    const newEntry = lodash_1.default.cloneDeep(entry);
    if (Array.isArray(newEntry)) {
        const entryKeys = Object.keys(newEntry[0]);
        for (let i = 0; i < newEntry.length; i++) {
            for (let j = 0; j < entryKeys.length; j++) {
                const entryKey = entryKeys[j];
                if (default_fields_regexp_1.default.test(entryKey)) {
                    delete newEntry[i][entryKey];
                }
            }
        }
        return newEntry;
    }
    else {
        const entryKeys = Object.keys(newEntry);
        for (let i = 0; i < entryKeys.length; i++) {
            const entryKey = entryKeys[i];
            if (default_fields_regexp_1.default.test(entryKey)) {
                delete newEntry[entryKey];
            }
        }
        return newEntry;
    }
}
