"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = setupGlobalNetwork;
const child_process_1 = require("child_process");
const grab_instance_global_network_name_1 = __importDefault(require("./grab-instance-global-network-name"));
const grab_ip_addresses_1 = __importDefault(require("./backend/names/grab-ip-addresses"));
function setupGlobalNetwork() {
    const globalNetworkName = (0, grab_instance_global_network_name_1.default)();
    const { globalIPPrefix } = (0, grab_ip_addresses_1.default)();
    try {
        (0, child_process_1.execSync)(`docker network rm ${globalNetworkName}`, {});
    }
    catch (error) { }
    let newNtwkCmd = `docker network create`;
    newNtwkCmd += ` --driver bridge`;
    newNtwkCmd += ` --subnet ${globalIPPrefix}.0/24`;
    newNtwkCmd += ` --gateway ${globalIPPrefix}.1`;
    newNtwkCmd += ` ${globalNetworkName}`;
    (0, child_process_1.execSync)(newNtwkCmd);
}
