import queryDSQLAPI from "../../functions/api/query-dsql-api";
import { AddMediaAPIBody, APIResponseObject } from "../../types";
import { DSQL_DATASQUIREL_USER_MEDIA } from "../../types/dsql";
import grabAPIBasePath from "../../utils/grab-api-base-path";

export default async function apiMediaPOST(
    params: AddMediaAPIBody
): Promise<
    APIResponseObject<
        DSQL_DATASQUIREL_USER_MEDIA | DSQL_DATASQUIREL_USER_MEDIA[]
    >
> {
    const basePath = grabAPIBasePath({ paradigm: "media" });

    const POST_MEDIA_RES = await queryDSQLAPI<AddMediaAPIBody>({
        method: "POST",
        path: basePath,
        body: params,
        apiKey: params.apiKey,
    });

    return POST_MEDIA_RES as APIResponseObject<
        DSQL_DATASQUIREL_USER_MEDIA | DSQL_DATASQUIREL_USER_MEDIA[]
    >;
}
