import mysql from "serverless-mysql";
import { UserType } from "../../types";
import connDbHandler from "../../utils/db/conn-db-handler";

type Params = {
    query?: string;
    values?: any[];
    database?: string;
    user: UserType;
};

export default async function suDbHandler({
    query,
    database,
    user,
    values,
}: Params) {
    const connection = mysql({
        config: {
            host: process.env.DSQL_DB_HOST,
            user: process.env.DSQL_DB_USERNAME,
            password: process.env.DSQL_DB_PASSWORD,
            database: database,
            charset: "utf8mb4",
        },
    });

    const results = await connDbHandler(connection, query);

    return results;
}
