import mysql from "serverless-mysql";
import { DSQL_TableSchemaType, UserType } from "../../types";
import grabMariadbMainUserForUser from "./grab-mariadb-main-user-for-user";
import connDbHandler from "../../utils/db/conn-db-handler";

type Params = {
    query?: string;
    values?: any[];
    database?: string;
    tableSchema?: DSQL_TableSchemaType;
    debug?: boolean;
    user: UserType;
};

export default async function userDbHandler({
    query,
    user,
    database,
    debug,
    tableSchema,
    values,
}: Params) {
    const { fullName, host, username, password } =
        await grabMariadbMainUserForUser({ user });

    const connection = mysql({
        config: {
            host,
            user: username,
            password: password,
            database: database,
            charset: "utf8mb4",
        },
    });

    const results = await connDbHandler(connection, query);

    return results;
}
