import dataTypeParser, { DataTypesWithNumbers } from "./data-type-parser";

export default function dataTypeConstructor(
    dataType: string,
    limit?: number,
    decimal?: number
) {
    let finalType = dataTypeParser(dataType).type;

    if (!DataTypesWithNumbers.includes(finalType)) {
        return finalType;
    }

    if (finalType == "VARCHAR") {
        return (finalType += `(${limit || 250})`);
    }

    if (
        finalType == "DECIMAL" ||
        finalType == "FLOAT" ||
        finalType == "DOUBLE"
    ) {
        return (finalType += `(${limit || 10},${decimal || 2})`);
    }

    if (limit && !decimal) finalType += `(${limit})`;
    if (limit && decimal) finalType += `(${limit},${decimal})`;
    return finalType;
}
