import { DSQL_FieldSchemaType, TextFieldTypesArray } from "../../../types";

export default function grabTextFieldType(
    field: DSQL_FieldSchemaType,
    nullReturn?: boolean
): (typeof TextFieldTypesArray)[number]["value"] | undefined {
    if (field.richText) return "richText";
    if (field.json) return "json";
    if (field.yaml) return "yaml";
    if (field.html) return "html";
    if (field.css) return "css";
    if (field.javascript) return "javascript";
    if (field.shell) return "shell";
    if (nullReturn) return undefined;
    return "plain";
}
