import { UserType } from "../types";
import grabSQLUserNameForUser from "./grab-sql-user-name-for-user";
import grabIPAddresses from "../utils/backend/names/grab-ip-addresses";

type Params = {
    user?: UserType | null;
    HOST?: string;
    username?: string;
};

export default function grabUserMainSqlUserName({
    HOST,
    user,
    username,
}: Params) {
    const sqlUsername = grabSQLUserNameForUser(user?.id);
    const { webAppIP, maxScaleIP } = grabIPAddresses();

    const finalUsername = username || sqlUsername;
    const finalHost = HOST || maxScaleIP || "127.0.0.1";
    const fullName = `${finalUsername}@${webAppIP}`;

    return {
        username: finalUsername,
        host: finalHost,
        webHost: webAppIP,
        fullName,
        sqlUsername,
    };
}
